blob: 7c16319b80bd139ad7cb82dd08f9d15283794260 [file] [log] [blame]
Peter Tyserf2352872009-12-06 23:58:28 -06001#!/bin/bash
Wolfgang Denk0777eaf2010-10-17 12:26:48 +02002# Tool mainly for U-Boot Quality Assurance: build one or more board
3# configurations with minimal verbosity, showing only warnings and
4# errors.
Wolfgang Denkeca3aeb2013-06-21 10:22:36 +02005#
6# SPDX-License-Identifier: GPL-2.0+
Wolfgang Denk0777eaf2010-10-17 12:26:48 +02007
Mike Frysingerd8e392d2011-04-21 22:01:43 +00008usage()
9{
10 # if exiting with 0, write to stdout, else write to stderr
11 local ret=${1:-0}
12 [ "${ret}" -eq 1 ] && exec 1>&2
13 cat <<-EOF
14 Usage: MAKEALL [options] [--] [boards-to-build]
15
16 Options:
17 -a ARCH, --arch ARCH Build all boards with arch ARCH
18 -c CPU, --cpu CPU Build all boards with cpu CPU
19 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
20 -s SOC, --soc SOC Build all boards with soc SOC
Masahiro Yamada4d1584b2013-11-21 19:06:58 +090021 -b BOARD, --board BOARD Build all boards with board name BOARD
Marek Vasut7f79c6f2011-12-02 21:32:03 +000022 -l, --list List all targets to be built
Marek Vasut9b96c6b2012-03-05 15:10:51 +000023 -m, --maintainers List all targets and maintainer email
24 -M, --mails List all targets and all affilated emails
Kim Phillips33f336d2012-09-27 14:57:34 +000025 -C, --check Enable build checking
Joe Hershberger08510202012-10-30 15:55:21 +000026 -n, --continue Continue (skip boards already built)
27 -r, --rebuild-errors Rebuild any boards that errored
Mike Frysingerd8e392d2011-04-21 22:01:43 +000028 -h, --help This help output
29
30 Selections by these options are logically ANDed; if the same option
31 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
32 will select all configurations where the vendor is either FOO or
33 BAR. Any additional arguments specified on the command line are
34 always build additionally. See the boards.cfg file for more info.
35
36 If no boards are specified, then the default is "powerpc".
37
38 Environment variables:
39 BUILD_NCPUS number of parallel make jobs (default: auto)
40 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
Allen Martin47104c32013-01-29 14:34:58 +000041 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
Wolfgang Denk93e14592013-10-04 17:43:24 +020042 architecture "ARCH". Substitute "ARCH" for any
43 supported architecture (default: "")
Mike Frysingerd8e392d2011-04-21 22:01:43 +000044 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
45 BUILD_DIR output build directory (default: ./)
Andy Flemingf588bb02012-04-24 19:33:51 +000046 BUILD_NBUILDS number of parallel targets (default: 1)
Mike Frysingerd8e392d2011-04-21 22:01:43 +000047
48 Examples:
49 - build all Power Architecture boards:
50 MAKEALL -a powerpc
51 MAKEALL --arch powerpc
52 MAKEALL powerpc
53 - build all PowerPC boards manufactured by vendor "esd":
54 MAKEALL -a powerpc -v esd
55 - build all PowerPC boards manufactured either by "keymile" or "siemens":
56 MAKEALL -a powerpc -v keymile -v siemens
57 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
58 MAKEALL -c mpc83xx -v freescale 4xx
59 EOF
60 exit ${ret}
61}
62
Masahiro Yamada4d1584b2013-11-21 19:06:58 +090063SHORT_OPTS="ha:c:v:s:b:lmMCnr"
64LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +020065
66# Option processing based on util-linux-2.13/getopt-parse.bash
67
Wolfgang Denk071bc922010-10-27 22:48:30 +020068# Note that we use `"$@"' to let each command-line parameter expand to a
Wolfgang Denk0777eaf2010-10-17 12:26:48 +020069# separate word. The quotes around `$@' are essential!
70# We need TEMP as the `eval set --' would nuke the return value of
71# getopt.
72TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
73 -n 'MAKEALL' -- "$@"`
74
Mike Frysingerd8e392d2011-04-21 22:01:43 +000075[ $? != 0 ] && usage 1
Wolfgang Denk0777eaf2010-10-17 12:26:48 +020076
77# Note the quotes around `$TEMP': they are essential!
78eval set -- "$TEMP"
79
80SELECTED=''
Marek Vasut7f79c6f2011-12-02 21:32:03 +000081ONLY_LIST=''
Marek Vasut9b96c6b2012-03-05 15:10:51 +000082PRINT_MAINTS=''
83MAINTAINERS_ONLY=''
Joe Hershberger08510202012-10-30 15:55:21 +000084CONTINUE=''
85REBUILD_ERRORS=''
Wolfgang Denk0777eaf2010-10-17 12:26:48 +020086
87while true ; do
88 case "$1" in
89 -a|--arch)
90 # echo "Option ARCH: argument \`$2'"
91 if [ "$opt_a" ] ; then
92 opt_a="${opt_a%)} || \$2 == \"$2\")"
93 else
94 opt_a="(\$2 == \"$2\")"
95 fi
96 SELECTED='y'
97 shift 2 ;;
98 -c|--cpu)
99 # echo "Option CPU: argument \`$2'"
100 if [ "$opt_c" ] ; then
Allen Martinaa2e2792012-08-31 08:30:06 +0000101 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200102 else
Allen Martinaa2e2792012-08-31 08:30:06 +0000103 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200104 fi
105 SELECTED='y'
106 shift 2 ;;
107 -s|--soc)
108 # echo "Option SoC: argument \`$2'"
109 if [ "$opt_s" ] ; then
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200110 opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200111 else
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200112 opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200113 fi
114 SELECTED='y'
115 shift 2 ;;
116 -v|--vendor)
117 # echo "Option VENDOR: argument \`$2'"
118 if [ "$opt_v" ] ; then
119 opt_v="${opt_v%)} || \$5 == \"$2\")"
120 else
121 opt_v="(\$5 == \"$2\")"
122 fi
123 SELECTED='y'
124 shift 2 ;;
Masahiro Yamada4d1584b2013-11-21 19:06:58 +0900125 -b|--board)
126 # echo "Option BOARD: argument \`$2'"
127 if [ "$opt_b" ] ; then
128 opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
129 else
130 # We need to check the 7th field too
131 # for boards whose 6th field is "-"
132 opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
133 fi
134 SELECTED='y'
135 shift 2 ;;
Kim Phillips33f336d2012-09-27 14:57:34 +0000136 -C|--check)
137 CHECK='C=1'
138 shift ;;
Joe Hershberger08510202012-10-30 15:55:21 +0000139 -n|--continue)
140 CONTINUE='y'
141 shift ;;
142 -r|--rebuild-errors)
143 REBUILD_ERRORS='y'
144 shift ;;
Marek Vasut7f79c6f2011-12-02 21:32:03 +0000145 -l|--list)
146 ONLY_LIST='y'
147 shift ;;
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000148 -m|--maintainers)
149 ONLY_LIST='y'
150 PRINT_MAINTS='y'
151 MAINTAINERS_ONLY='y'
152 shift ;;
153 -M|--mails)
154 ONLY_LIST='y'
155 PRINT_MAINTS='y'
156 shift ;;
Mike Frysingerd8e392d2011-04-21 22:01:43 +0000157 -h|--help)
158 usage ;;
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200159 --)
160 shift ; break ;;
161 *)
162 echo "Internal error!" >&2 ; exit 1 ;;
163 esac
164done
Masahiro Yamadae18fd942014-07-22 11:19:08 +0900165
166GNU_MAKE=$(scripts/show-gnu-make) || {
167 echo "GNU Make not found" >&2
168 exit 1
169}
170
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200171# echo "Remaining arguments:"
172# for arg do echo '--> '"\`$arg'" ; done
173
Masahiro Yamada94ab8f42014-08-22 14:33:40 +0900174tools/genboardscfg.py || {
175 echo "Failed to generate boards.cfg" >&2
176 exit 1
177}
Masahiro Yamadabb6da872014-07-30 14:08:21 +0900178
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200179FILTER="\$1 !~ /^#/"
180[ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
181[ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
182[ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
183[ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
Masahiro Yamada4d1584b2013-11-21 19:06:58 +0900184[ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200185
186if [ "$SELECTED" ] ; then
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200187 SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
Peter Tysercd57b0b2010-10-29 17:59:06 -0500188
189 # Make sure some boards from boards.cfg are actually found
190 if [ -z "$SELECTED" ] ; then
191 echo "Error: No boards selected, invalid arguments"
192 exit 1
193 fi
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200194fi
195
196#########################################################################
197
Peter Tyser40a28f02009-09-21 12:04:32 -0500198# Print statistics when we exit
199trap exit 1 2 3 15
200trap print_stats 0
201
Wolfgang Denk7fa6a2f2008-12-09 00:39:08 +0100202# Determine number of CPU cores if no default was set
203: ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
204
205if [ "$BUILD_NCPUS" -gt 1 ]
206then
Peter Tyser55f786d2009-09-21 12:04:33 -0500207 JOBS="-j $((BUILD_NCPUS + 1))"
Wolfgang Denk7fa6a2f2008-12-09 00:39:08 +0100208else
209 JOBS=""
210fi
211
Marian Balakowiczf9328632006-09-01 19:49:50 +0200212if [ "${MAKEALL_LOGDIR}" ] ; then
213 LOG_DIR=${MAKEALL_LOGDIR}
214else
215 LOG_DIR="LOG"
216fi
Stefan Roese887e2ec2006-09-07 11:51:23 +0200217
Andy Flemingf588bb02012-04-24 19:33:51 +0000218: ${BUILD_NBUILDS:=1}
219BUILD_MANY=0
220
221if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
222 BUILD_MANY=1
223 : ${BUILD_DIR:=./build}
224 mkdir -p "${BUILD_DIR}/ERR"
225 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
Marian Balakowiczf9328632006-09-01 19:49:50 +0200226fi
227
Andy Flemingf588bb02012-04-24 19:33:51 +0000228: ${BUILD_DIR:=.}
229
230OUTPUT_PREFIX="${BUILD_DIR}"
231
232[ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
Joe Hershberger08510202012-10-30 15:55:21 +0000233if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
234 find "${LOG_DIR}/" -type f -exec rm -f {} +
235fi
wdenk7ebf7442002-11-02 23:17:16 +0000236
237LIST=""
238
Peter Tyser40a28f02009-09-21 12:04:32 -0500239# Keep track of the number of builds and errors
240ERR_CNT=0
241ERR_LIST=""
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000242WRN_CNT=0
243WRN_LIST=""
Peter Tyser40a28f02009-09-21 12:04:32 -0500244TOTAL_CNT=0
Joe Hershberger08510202012-10-30 15:55:21 +0000245SKIP_CNT=0
Andy Flemingf588bb02012-04-24 19:33:51 +0000246CURRENT_CNT=0
247OLDEST_IDX=1
Peter Tyserf2352872009-12-06 23:58:28 -0600248RC=0
Peter Tyser40a28f02009-09-21 12:04:32 -0500249
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400250# Helper funcs for parsing boards.cfg
Masahiro Yamada89487942013-10-21 11:11:28 +0900251targets_by_field()
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400252{
Masahiro Yamada8e5a2d42013-10-21 11:11:27 +0900253 field=$1
254 regexp=$2
255
256 awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
257 boards.cfg
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400258}
Masahiro Yamada8e5a2d42013-10-21 11:11:27 +0900259
Masahiro Yamada89487942013-10-21 11:11:28 +0900260targets_by_arch() { targets_by_field 2 "$@" ; }
261targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
262targets_by_soc() { targets_by_field 4 "$@" ; }
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400263
wdenk7ebf7442002-11-02 23:17:16 +0000264#########################################################################
wdenk0db5bca2003-03-31 17:27:09 +0000265## MPC5xx Systems
266#########################################################################
267
Masahiro Yamada89487942013-10-21 11:11:28 +0900268LIST_5xx="$(targets_by_cpu mpc5xx)"
wdenk0db5bca2003-03-31 17:27:09 +0000269
270#########################################################################
wdenk945af8d2003-07-16 21:53:01 +0000271## MPC5xxx Systems
272#########################################################################
273
Masahiro Yamada89487942013-10-21 11:11:28 +0900274LIST_5xxx="$(targets_by_cpu mpc5xxx)"
wdenk945af8d2003-07-16 21:53:01 +0000275
276#########################################################################
Rafal Jaworowski8993e542007-07-27 14:43:59 +0200277## MPC512x Systems
278#########################################################################
279
Masahiro Yamada89487942013-10-21 11:11:28 +0900280LIST_512x="$(targets_by_cpu mpc512x)"
wdenk7ebf7442002-11-02 23:17:16 +0000281
282#########################################################################
283## MPC8xx Systems
284#########################################################################
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400285
Masahiro Yamada89487942013-10-21 11:11:28 +0900286LIST_8xx="$(targets_by_cpu mpc8xx)"
wdenk7ebf7442002-11-02 23:17:16 +0000287
288#########################################################################
289## PPC4xx Systems
290#########################################################################
291
Masahiro Yamada89487942013-10-21 11:11:28 +0900292LIST_4xx="$(targets_by_cpu ppc4xx)"
wdenk7ebf7442002-11-02 23:17:16 +0000293
294#########################################################################
295## MPC824x Systems
296#########################################################################
297
Masahiro Yamada89487942013-10-21 11:11:28 +0900298LIST_824x="$(targets_by_cpu mpc824x)"
wdenk592c5ca2003-06-21 00:17:24 +0000299
wdenk7ebf7442002-11-02 23:17:16 +0000300#########################################################################
wdenk7aa78612003-05-03 15:50:43 +0000301## MPC8260 Systems (includes 8250, 8255 etc.)
wdenk7ebf7442002-11-02 23:17:16 +0000302#########################################################################
303
Masahiro Yamada89487942013-10-21 11:11:28 +0900304LIST_8260="$(targets_by_cpu mpc8260)"
wdenk7ebf7442002-11-02 23:17:16 +0000305
306#########################################################################
Eran Libertyf046ccd2005-07-28 10:08:46 -0500307## MPC83xx Systems (includes 8349, etc.)
308#########################################################################
309
Masahiro Yamada89487942013-10-21 11:11:28 +0900310LIST_83xx="$(targets_by_cpu mpc83xx)"
Eran Libertyf046ccd2005-07-28 10:08:46 -0500311
312#########################################################################
wdenk42d1f032003-10-15 23:53:47 +0000313## MPC85xx Systems (includes 8540, 8560 etc.)
314#########################################################################
315
Masahiro Yamada89487942013-10-21 11:11:28 +0900316LIST_85xx="$(targets_by_cpu mpc85xx)"
wdenk42d1f032003-10-15 23:53:47 +0000317
318#########################################################################
Jon Loeliger822d5532007-05-23 14:09:46 -0500319## MPC86xx Systems
320#########################################################################
321
Masahiro Yamada89487942013-10-21 11:11:28 +0900322LIST_86xx="$(targets_by_cpu mpc86xx)"
Jon Loeliger822d5532007-05-23 14:09:46 -0500323
324#########################################################################
wdenk7ebf7442002-11-02 23:17:16 +0000325## 74xx/7xx Systems
326#########################################################################
327
Masahiro Yamada89487942013-10-21 11:11:28 +0900328LIST_74xx_7xx="$(targets_by_cpu 74xx_7xx)"
wdenk7ebf7442002-11-02 23:17:16 +0000329
Wolfgang Denkd9a42c02008-04-20 15:35:52 -0700330#########################################################################
331## PowerPC groups
332#########################################################################
333
334LIST_TSEC=" \
335 ${LIST_83xx} \
336 ${LIST_85xx} \
337 ${LIST_86xx} \
338"
339
Stefan Roesea47a12b2010-04-15 16:07:28 +0200340LIST_powerpc=" \
Kim Phillipsfb565792007-08-10 15:34:48 -0500341 ${LIST_5xx} \
Jean-Christophe PLAGNIOL-VILLARD3deca9d2007-11-25 22:39:25 +0100342 ${LIST_512x} \
Kim Phillipsfb565792007-08-10 15:34:48 -0500343 ${LIST_5xxx} \
344 ${LIST_8xx} \
Kim Phillipsfb565792007-08-10 15:34:48 -0500345 ${LIST_824x} \
346 ${LIST_8260} \
347 ${LIST_83xx} \
348 ${LIST_85xx} \
349 ${LIST_86xx} \
350 ${LIST_4xx} \
Wolfgang Denk2ae18242010-10-06 09:05:45 +0200351 ${LIST_74xx_7xx}\
Kim Phillipsfb565792007-08-10 15:34:48 -0500352"
wdenk7ebf7442002-11-02 23:17:16 +0000353
Stefan Roesea47a12b2010-04-15 16:07:28 +0200354# Alias "ppc" -> "powerpc" to not break compatibility with older scripts
355# still using "ppc" instead of "powerpc"
356LIST_ppc=" \
357 ${LIST_powerpc} \
358"
359
wdenk7ebf7442002-11-02 23:17:16 +0000360#########################################################################
361## StrongARM Systems
362#########################################################################
363
Masahiro Yamada89487942013-10-21 11:11:28 +0900364LIST_SA="$(targets_by_cpu sa1100)"
wdenk7ebf7442002-11-02 23:17:16 +0000365
366#########################################################################
Allen Martincce5d212012-08-29 11:08:59 +0000367## ARM7 Systems
368#########################################################################
369
Masahiro Yamada89487942013-10-21 11:11:28 +0900370LIST_ARM7="$(targets_by_cpu arm720t)"
Allen Martincce5d212012-08-29 11:08:59 +0000371
372#########################################################################
wdenk7ebf7442002-11-02 23:17:16 +0000373## ARM9 Systems
374#########################################################################
375
Masahiro Yamada89487942013-10-21 11:11:28 +0900376LIST_ARM9="$(targets_by_cpu arm920t) \
377 $(targets_by_cpu arm926ejs) \
378 $(targets_by_cpu arm946es) \
wdenk6f213472003-08-29 22:00:43 +0000379"
wdenk7ebf7442002-11-02 23:17:16 +0000380
381#########################################################################
wdenk8ed96042005-01-09 23:16:25 +0000382## ARM11 Systems
383#########################################################################
Masahiro Yamada89487942013-10-21 11:11:28 +0900384LIST_ARM11="$(targets_by_cpu arm1136) \
385 $(targets_by_cpu arm1176) \
Allen Martincce5d212012-08-29 11:08:59 +0000386"
wdenk8ed96042005-01-09 23:16:25 +0000387
388#########################################################################
Steve Sakomanf56348a2010-06-17 21:50:01 -0700389## ARMV7 Systems
Dirk Behmef904cdb2009-01-27 18:19:12 +0100390#########################################################################
Dirk Behmef37586b2011-08-05 20:48:32 +0000391
Masahiro Yamada89487942013-10-21 11:11:28 +0900392LIST_ARMV7="$(targets_by_cpu armv7)"
Dirk Behmef904cdb2009-01-27 18:19:12 +0100393
394#########################################################################
David Feng2475e632013-12-14 11:47:38 +0800395## ARMV8 Systems
396#########################################################################
397
398LIST_ARMV8="$(targets_by_cpu armv8)"
399
400#########################################################################
Jean-Christophe PLAGNIOL-VILLARD602cac12008-05-24 12:47:46 +0200401## AT91 Systems
402#########################################################################
403
Masahiro Yamada89487942013-10-21 11:11:28 +0900404LIST_at91="$(targets_by_soc at91)"
Jean-Christophe PLAGNIOL-VILLARD602cac12008-05-24 12:47:46 +0200405
406#########################################################################
wdenk7ebf7442002-11-02 23:17:16 +0000407## Xscale Systems
408#########################################################################
409
Masahiro Yamada89487942013-10-21 11:11:28 +0900410LIST_pxa="$(targets_by_cpu pxa)"
wdenk7ebf7442002-11-02 23:17:16 +0000411
Wolfgang Denkd9a42c02008-04-20 15:35:52 -0700412#########################################################################
Stefan Roese24dede42012-05-30 22:59:43 +0000413## SPEAr Systems
414#########################################################################
415
Masahiro Yamada89487942013-10-21 11:11:28 +0900416LIST_spear="$(targets_by_soc spear)"
Stefan Roese24dede42012-05-30 22:59:43 +0000417
418#########################################################################
Wolfgang Denkd9a42c02008-04-20 15:35:52 -0700419## ARM groups
420#########################################################################
wdenk2d5b5612003-10-14 19:43:55 +0000421
David Feng2475e632013-12-14 11:47:38 +0800422LIST_arm="$(targets_by_arch arm | \
423 for ARMV8_TARGET in $LIST_ARMV8; \
424 do sed "/$ARMV8_TARGET/d"; \
425 done) \
426"
wdenk7ebf7442002-11-02 23:17:16 +0000427
wdenkc0218802003-03-27 12:09:35 +0000428#########################################################################
Wolfgang Denkb62bdff2005-08-14 00:27:00 +0200429## MIPS Systems (default = big endian)
wdenkc0218802003-03-27 12:09:35 +0000430#########################################################################
431
Daniel Schwierzecked638b62014-04-17 21:45:59 +0200432LIST_mips="$(targets_by_arch mips)"
wdenkc0218802003-03-27 12:09:35 +0000433
Stefan Kristianssondeddf5d2011-11-18 19:21:37 +0000434#########################################################################
435## OpenRISC Systems
436#########################################################################
437
Masahiro Yamada89487942013-10-21 11:11:28 +0900438LIST_openrisc="$(targets_by_arch openrisc)"
Wolfgang Denkb62bdff2005-08-14 00:27:00 +0200439
440#########################################################################
Graeme Russfea25722011-04-13 19:43:28 +1000441## x86 Systems
wdenk7a8e9bed2003-05-31 18:35:21 +0000442#########################################################################
443
Masahiro Yamada89487942013-10-21 11:11:28 +0900444LIST_x86="$(targets_by_arch x86)"
wdenk7a8e9bed2003-05-31 18:35:21 +0000445
wdenkc935d3b2004-01-03 19:43:48 +0000446#########################################################################
wdenk5c952cf2004-10-10 21:27:30 +0000447## Nios-II Systems
448#########################################################################
449
Masahiro Yamada89487942013-10-21 11:11:28 +0900450LIST_nios2="$(targets_by_arch nios2)"
wdenk5c952cf2004-10-10 21:27:30 +0000451
452#########################################################################
wdenk857cad32004-07-10 23:48:41 +0000453## MicroBlaze Systems
454#########################################################################
455
Masahiro Yamada89487942013-10-21 11:11:28 +0900456LIST_microblaze="$(targets_by_arch microblaze)"
wdenk857cad32004-07-10 23:48:41 +0000457
Zachary P. Landauf8c3b4f2006-01-26 17:38:46 -0500458#########################################################################
459## ColdFire Systems
460#########################################################################
461
Masahiro Yamada89487942013-10-21 11:11:28 +0900462LIST_m68k="$(targets_by_arch m68k)"
Mike Frysingerc13f47b2011-09-25 19:27:19 +0000463LIST_coldfire=${LIST_m68k}
Zachary P. Landauf8c3b4f2006-01-26 17:38:46 -0500464
Wolfgang Denk6ccec442006-10-24 14:42:37 +0200465#########################################################################
466## AVR32 Systems
467#########################################################################
468
Masahiro Yamada89487942013-10-21 11:11:28 +0900469LIST_avr32="$(targets_by_arch avr32)"
Wolfgang Denk6ccec442006-10-24 14:42:37 +0200470
Aubrey.Lief26a082007-03-09 13:40:56 +0800471#########################################################################
472## Blackfin Systems
473#########################################################################
474
Masahiro Yamada89487942013-10-21 11:11:28 +0900475LIST_blackfin="$(targets_by_arch blackfin)"
Aubrey.Lief26a082007-03-09 13:40:56 +0800476
Jean-Christophe PLAGNIOL-VILLARDc7144372007-11-27 09:44:53 +0100477#########################################################################
478## SH Systems
479#########################################################################
480
Masahiro Yamada89487942013-10-21 11:11:28 +0900481LIST_sh2="$(targets_by_cpu sh2)"
482LIST_sh3="$(targets_by_cpu sh3)"
483LIST_sh4="$(targets_by_cpu sh4)"
Wolfgang Denkd9a42c02008-04-20 15:35:52 -0700484
Masahiro Yamada89487942013-10-21 11:11:28 +0900485LIST_sh="$(targets_by_arch sh)"
Jean-Christophe PLAGNIOL-VILLARDc7144372007-11-27 09:44:53 +0100486
Daniel Hellstromc2f02da2008-03-28 09:47:00 +0100487#########################################################################
488## SPARC Systems
489#########################################################################
490
Masahiro Yamada89487942013-10-21 11:11:28 +0900491LIST_sparc="$(targets_by_arch sparc)"
wdenk7ebf7442002-11-02 23:17:16 +0000492
Macpaul Lin5f1719c2011-10-19 20:41:10 +0000493#########################################################################
494## NDS32 Systems
495#########################################################################
496
Masahiro Yamada89487942013-10-21 11:11:28 +0900497LIST_nds32="$(targets_by_arch nds32)"
Macpaul Lin5f1719c2011-10-19 20:41:10 +0000498
Alexey Brodkin568c1fa2014-02-04 12:56:20 +0400499#########################################################################
500## ARC Systems
501#########################################################################
502
503LIST_arc="$(targets_by_arch arc)"
504
wdenk7ebf7442002-11-02 23:17:16 +0000505#-----------------------------------------------------------------------
506
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000507get_target_location() {
508 local target=$1
509 local BOARD_NAME=""
510 local CONFIG_NAME=""
511 local board=""
512 local vendor=""
513
514 # Automatic mode
Masahiro Yamada23d64102013-10-21 11:11:25 +0900515 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000516 if [ -z "${line}" ] ; then echo "" ; return ; fi
517
518 set ${line}
519
Masahiro Yamadabb6da872014-07-30 14:08:21 +0900520 CONFIG_NAME="${7%_defconfig}"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000521
Masahiro Yamadabb6da872014-07-30 14:08:21 +0900522 [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_defconfig}"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000523
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200524 if [ $# -gt 5 ]; then
525 if [ "$6" = "-" ] ; then
526 board=${BOARD_NAME}
527 else
528 board="$6"
529 fi
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000530 fi
531
532 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200533 [ $# -gt 6 ] && [ "$8" != "-" ] && {
534 tmp="${8%:*}"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000535 if [ "$tmp" ] ; then
536 CONFIG_NAME="$tmp"
537 fi
538 }
539
540 # Assign board directory to BOARDIR variable
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200541 if [ "${vendor}" == "-" ] ; then
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000542 BOARDDIR=${board}
543 else
544 BOARDDIR=${vendor}/${board}
545 fi
546
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200547 echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000548}
549
550get_target_maintainers() {
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200551 local name=`echo $1 | cut -d : -f 3`
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000552
Masahiro Yamada23d64102013-10-21 11:11:25 +0900553 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200554 if [ -z "${line}" ]; then
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000555 echo ""
556 return ;
557 fi
558
Albert ARIBAUD27af9302013-09-11 15:52:51 +0200559 local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
560 [ "$mails" == "-" ] && mails=""
561 echo "$mails"
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000562}
563
Allen Martin47104c32013-01-29 14:34:58 +0000564get_target_arch() {
565 local target=$1
566
567 # Automatic mode
Masahiro Yamada54d1f502013-10-21 11:11:26 +0900568 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
Allen Martin47104c32013-01-29 14:34:58 +0000569
570 if [ -z "${line}" ] ; then echo "" ; return ; fi
571
572 set ${line}
573 echo "$2"
574}
575
Marek Vasut9b96c6b2012-03-05 15:10:51 +0000576list_target() {
577 if [ "$PRINT_MAINTS" != 'y' ] ; then
578 echo "$1"
579 return
580 fi
581
582 echo -n "$1:"
583
584 local loc=`get_target_location $1`
585
586 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
587
588 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
589
590 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
591
592 local dir=`echo ${loc} | cut -d ":" -f 2`
593 local cfg=`echo ${loc} | cut -d ":" -f 1`
594 local git_result=`git log --format=%aE board/${dir} \
595 include/configs/${cfg}.h | grep "@"`
596 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
597 head -n 3`
598 local git_result_top=`echo ${git_result} | tr " " "\n" | \
599 sort | uniq -c | sort -nr | head -n 3 | \
600 sed "s/^ \+[0-9]\+ \+//"`
601
602 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
603 sort -u | tr "\n" " " | sed "s/ $//" ;
604 else
605 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
606 sed "s/ $//" ;
607 fi
608
609 echo ""
610}
611
Andy Flemingf588bb02012-04-24 19:33:51 +0000612# Each finished build will have a file called ${donep}${n},
613# where n is the index of the build. Each build
614# we've already noted as finished will have ${skipp}${n}.
615# The code managing the build process will use this information
616# to ensure that only BUILD_NBUILDS builds are in flight at once
617donep="${LOG_DIR}/._done_"
618skipp="${LOG_DIR}/._skip_"
619
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000620build_target_killed() {
621 echo "Aborted $target build."
622 # Remove the logs for this board since it was aborted
623 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
624 exit
625}
626
wdenk7ebf7442002-11-02 23:17:16 +0000627build_target() {
628 target=$1
Andy Flemingf588bb02012-04-24 19:33:51 +0000629 build_idx=$2
630
Andy Flemingf50bf502012-05-09 20:36:28 +0000631 if [ "$ONLY_LIST" == 'y' ] ; then
632 list_target ${target}
633 return
634 fi
635
Andy Flemingf588bb02012-04-24 19:33:51 +0000636 if [ $BUILD_MANY == 1 ] ; then
637 output_dir="${OUTPUT_PREFIX}/${target}"
638 mkdir -p "${output_dir}"
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000639 trap build_target_killed TERM
Andy Flemingf588bb02012-04-24 19:33:51 +0000640 else
641 output_dir="${OUTPUT_PREFIX}"
642 fi
643
Allen Martin47104c32013-01-29 14:34:58 +0000644 target_arch=$(get_target_arch ${target})
York Sunc17b94e2013-03-22 07:37:03 +0000645 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
Allen Martin47104c32013-01-29 14:34:58 +0000646 if [ "${cross_toolchain}" ] ; then
Masahiro Yamadae18fd942014-07-22 11:19:08 +0900647 MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}"
Allen Martin47104c32013-01-29 14:34:58 +0000648 elif [ "${CROSS_COMPILE}" ] ; then
Masahiro Yamadae18fd942014-07-22 11:19:08 +0900649 MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}"
Allen Martin47104c32013-01-29 14:34:58 +0000650 else
Masahiro Yamadae18fd942014-07-22 11:19:08 +0900651 MAKE=$GNU_MAKE
Allen Martin47104c32013-01-29 14:34:58 +0000652 fi
653
Masahiro Yamada9e414032014-02-04 17:24:24 +0900654 if [ "${output_dir}" != "." ] ; then
655 MAKE="${MAKE} O=${output_dir}"
656 fi
657
Roger Meierfd18a892014-08-20 22:10:29 +0200658 ${MAKE} mrproper >/dev/null
Masahiro Yamadabb6da872014-07-30 14:08:21 +0900659
660 echo "Building ${target} board..."
661 ${MAKE} -s ${target}_defconfig >/dev/null
Marian Balakowiczf9328632006-09-01 19:49:50 +0200662
Kim Phillips33f336d2012-09-27 14:57:34 +0000663 ${MAKE} ${JOBS} ${CHECK} all \
Andy Flemingf588bb02012-04-24 19:33:51 +0000664 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
Peter Tyserf2352872009-12-06 23:58:28 -0600665
666 # Check for 'make' errors
667 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
668 RC=1
669 fi
670
Andy Flemingf588bb02012-04-24 19:33:51 +0000671 if [ $BUILD_MANY == 1 ] ; then
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000672 trap - TERM
673
Masahiro Yamada73906432014-02-04 17:24:34 +0900674 ${MAKE} -s clean
Andy Flemingf588bb02012-04-24 19:33:51 +0000675
676 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000677 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
Andy Flemingf588bb02012-04-24 19:33:51 +0000678 else
679 rm ${LOG_DIR}/${target}.ERR
680 fi
Peter Tyser40a28f02009-09-21 12:04:32 -0500681 else
Andy Flemingf588bb02012-04-24 19:33:51 +0000682 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000683 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
684 : $(( ERR_CNT += 1 ))
685 ERR_LIST="${ERR_LIST} $target"
686 else
687 : $(( WRN_CNT += 1 ))
688 WRN_LIST="${WRN_LIST} $target"
689 fi
Andy Flemingf588bb02012-04-24 19:33:51 +0000690 else
691 rm ${LOG_DIR}/${target}.ERR
692 fi
Peter Tyser40a28f02009-09-21 12:04:32 -0500693 fi
694
Andy Flemingf588bb02012-04-24 19:33:51 +0000695 OBJS=${output_dir}/u-boot
696 if [ -e ${output_dir}/spl/u-boot-spl ]; then
697 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
Scott Wood0c185692012-02-20 12:56:25 +0000698 fi
699
700 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
Andy Flemingf588bb02012-04-24 19:33:51 +0000701
702 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
703
Andy Flemingf588bb02012-04-24 19:33:51 +0000704 touch "${donep}${build_idx}"
wdenk7ebf7442002-11-02 23:17:16 +0000705}
Andy Flemingf588bb02012-04-24 19:33:51 +0000706
707manage_builds() {
708 search_idx=${OLDEST_IDX}
Andy Flemingf50bf502012-05-09 20:36:28 +0000709 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
710
Andy Flemingf588bb02012-04-24 19:33:51 +0000711 while true; do
712 if [ -e "${donep}${search_idx}" ] ; then
Andy Flemingf588bb02012-04-24 19:33:51 +0000713 : $(( CURRENT_CNT-- ))
714 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
715 : $(( OLDEST_IDX++ ))
716
717 # Only want to count it once
718 rm -f "${donep}${search_idx}"
719 touch "${skipp}${search_idx}"
720 elif [ -e "${skipp}${search_idx}" ] ; then
721 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
722 : $(( OLDEST_IDX++ ))
723 fi
Andy Flemingf588bb02012-04-24 19:33:51 +0000724 : $(( search_idx++ ))
725 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
Andy Flemingf588bb02012-04-24 19:33:51 +0000726 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
727 search_idx=${OLDEST_IDX}
728 sleep 1
729 else
730 break
731 fi
732 fi
733 done
734}
735
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400736build_targets() {
737 for t in "$@" ; do
738 # If a LIST_xxx var exists, use it. But avoid variable
739 # expansion in the eval when a board name contains certain
740 # characters that the shell interprets.
741 case ${t} in
742 *[-+=]*) list= ;;
743 *) list=$(eval echo '${LIST_'$t'}') ;;
744 esac
745 if [ -n "${list}" ] ; then
746 build_targets ${list}
747 else
Andy Flemingf588bb02012-04-24 19:33:51 +0000748 : $((TOTAL_CNT += 1))
749 : $((CURRENT_CNT += 1))
750 rm -f "${donep}${TOTAL_CNT}"
751 rm -f "${skipp}${TOTAL_CNT}"
Joe Hershberger08510202012-10-30 15:55:21 +0000752 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
753 : $((SKIP_CNT += 1))
754 touch "${donep}${TOTAL_CNT}"
755 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
756 : $((SKIP_CNT += 1))
757 touch "${donep}${TOTAL_CNT}"
Joe Hershbergerb594bd62012-05-21 04:49:37 +0000758 else
Joe Hershberger08510202012-10-30 15:55:21 +0000759 if [ $BUILD_MANY == 1 ] ; then
760 build_target ${t} ${TOTAL_CNT} &
761 else
762 CUR_TGT="${t}"
763 build_target ${t} ${TOTAL_CNT}
764 CUR_TGT=''
765 fi
Joe Hershbergerb594bd62012-05-21 04:49:37 +0000766 fi
Andy Flemingf588bb02012-04-24 19:33:51 +0000767 fi
768
769 # We maintain a running count of all the builds we have done.
770 # Each finished build will have a file called ${donep}${n},
771 # where n is the index of the build. Each build
772 # we've already noted as finished will have ${skipp}${n}.
773 # We track the current index via TOTAL_CNT, and the oldest
774 # index. When we exceed the maximum number of parallel builds,
775 # We look from oldest to current for builds that have completed,
776 # and update the current count and oldest index as appropriate.
777 # If we've gone through the entire list, wait a second, and
778 # reprocess the entire list until we find a build that has
779 # completed
780 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
781 manage_builds
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400782 fi
783 done
784}
wdenk7ebf7442002-11-02 23:17:16 +0000785
786#-----------------------------------------------------------------------
787
Andy Flemingf50bf502012-05-09 20:36:28 +0000788kill_children() {
Andreas Bießmann6bdd9f82013-02-07 22:35:57 +0000789 local OS=$(uname -s)
790 local children=""
791 case "${OS}" in
792 "Darwin")
793 # Mac OS X is known to have BSD style ps
794 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
795 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
796 ;;
797 *)
798 # everything else tries the GNU style
799 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
800 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
801 ;;
802 esac
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000803
804 kill $children 2> /dev/null
805 wait $children 2> /dev/null
Andy Flemingf50bf502012-05-09 20:36:28 +0000806
807 exit
808}
809
Peter Tyser40a28f02009-09-21 12:04:32 -0500810print_stats() {
Marek Vasut7f79c6f2011-12-02 21:32:03 +0000811 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
Andy Flemingf588bb02012-04-24 19:33:51 +0000812
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000813 # Only count boards that completed
814 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
815
Andy Flemingf588bb02012-04-24 19:33:51 +0000816 rm -f ${donep}* ${skipp}*
817
818 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
Andy Fleming033220e2012-08-08 14:12:30 +0000819 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000820 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
821 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
Andy Fleming033220e2012-08-08 14:12:30 +0000822 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000823 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
824 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000825 else
826 # Remove the logs for any board that was interrupted
827 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
Andy Flemingf588bb02012-04-24 19:33:51 +0000828 fi
829
Joe Hershberger08510202012-10-30 15:55:21 +0000830 : $((TOTAL_CNT -= ${SKIP_CNT}))
Peter Tyser40a28f02009-09-21 12:04:32 -0500831 echo ""
832 echo "--------------------- SUMMARY ----------------------------"
Joe Hershberger08510202012-10-30 15:55:21 +0000833 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
834 echo "Boards skipped: ${SKIP_CNT}"
835 fi
Peter Tyser40a28f02009-09-21 12:04:32 -0500836 echo "Boards compiled: ${TOTAL_CNT}"
837 if [ ${ERR_CNT} -gt 0 ] ; then
Joe Hershbergerb86a4752012-05-21 04:49:38 +0000838 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
839 fi
840 if [ ${WRN_CNT} -gt 0 ] ; then
841 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
Peter Tyser40a28f02009-09-21 12:04:32 -0500842 fi
843 echo "----------------------------------------------------------"
Peter Tyserf2352872009-12-06 23:58:28 -0600844
Andy Flemingf50bf502012-05-09 20:36:28 +0000845 if [ $BUILD_MANY == 1 ] ; then
Joe Hershbergerc97d59c2012-10-30 15:55:20 +0000846 kill_children
Andy Flemingf50bf502012-05-09 20:36:28 +0000847 fi
848
Peter Tyserf2352872009-12-06 23:58:28 -0600849 exit $RC
Peter Tyser40a28f02009-09-21 12:04:32 -0500850}
wdenk7ebf7442002-11-02 23:17:16 +0000851
Peter Tyser40a28f02009-09-21 12:04:32 -0500852#-----------------------------------------------------------------------
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400853
Wolfgang Denk0777eaf2010-10-17 12:26:48 +0200854# Build target groups selected by options, plus any command line args
855set -- ${SELECTED} "$@"
856# run PowerPC by default
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400857[ $# = 0 ] && set -- powerpc
Mike Frysinger9ec49f82010-08-19 13:05:06 -0400858build_targets "$@"
Andy Flemingf588bb02012-04-24 19:33:51 +0000859wait